Torque2D Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
b2WheelJoint Class Reference

`#include <b2WheelJoint.h>`

Inheritance diagram for b2WheelJoint:

## Public Member Functions
void | GetDefinition (b2WheelJointDef *def) const
b2Vec2 | GetAnchorA () const
| Get the anchor point on bodyA in world coordinates. More...
b2Vec2 | GetAnchorB () const
| Get the anchor point on bodyB in world coordinates. More...
b2Vec2 | GetReactionForce (float32 inv_dt) const
| Get the reaction force on bodyB at the joint anchor in Newtons. More...
float32 | GetReactionTorque (float32 inv_dt) const
| Get the reaction torque on bodyB in N*m. More...
const b2Vec2 & | GetLocalAnchorA () const
| The local anchor point relative to bodyA's origin. More...
const b2Vec2 & | GetLocalAnchorB () const
| The local anchor point relative to bodyB's origin. More...
const b2Vec2 & | GetLocalAxisA () const
| The local joint axis relative to bodyA. More...
float32 | GetJointTranslation () const
| Get the current joint translation, usually in meters. More...
float32 | GetJointSpeed () const
| Get the current joint translation speed, usually in meters per second. More...
bool | IsMotorEnabled () const
| Is the joint motor enabled? More...
void | EnableMotor (bool flag)
| Enable/disable the joint motor. More...
void | SetMotorSpeed (float32 speed)
| Set the motor speed, usually in radians per second. More...
float32 | GetMotorSpeed () const
| Get the motor speed, usually in radians per second. More...
void | SetMaxMotorTorque (float32 torque)
| Set/Get the maximum motor force, usually in N-m. More...
float32 | GetMaxMotorTorque () const
float32 | GetMotorTorque (float32 inv_dt) const
| Get the current motor torque given the inverse time step, usually in N-m. More...
void | SetSpringFrequencyHz (float32 hz)
| Set/Get the spring frequency in hertz. Setting the frequency to zero disables the spring. More...
float32 | GetSpringFrequencyHz () const
void | SetSpringDampingRatio (float32 ratio)
| Set/Get the spring damping ratio. More...
float32 | GetSpringDampingRatio () const
void | Dump ()
| Dump to b2Log. More...
Public Member Functions inherited from b2Joint
b2JointType | GetType () const
| Get the type of the concrete joint. More...
b2Body * | GetBodyA ()
| Get the first body attached to this joint. More...
b2Body * | GetBodyB ()
| Get the second body attached to this joint. More...
b2Joint * | GetNext ()
| Get the next joint the world joint list. More...
const b2Joint * | GetNext () const
void * | GetUserData () const
| Get the user data pointer. More...
void | SetUserData (void *data)
| Set the user data pointer. More...
bool | IsActive () const
| Short-cut function to determine if either body is inactive. More...
bool | GetCollideConnected () const
virtual void | ShiftOrigin (const b2Vec2 &newOrigin)
| Shift the origin for any points stored in world coordinates. More...

## Protected Member Functions
| b2WheelJoint (const b2WheelJointDef *def)
void | InitVelocityConstraints (const b2SolverData &data)
void | SolveVelocityConstraints (const b2SolverData &data)
bool | SolvePositionConstraints (const b2SolverData &data)
Protected Member Functions inherited from b2Joint
| b2Joint (const b2JointDef *def)
virtual | ~b2Joint ()

## Protected Attributes
float32 | m_frequencyHz
float32 | m_dampingRatio
b2Vec2 | m_localAnchorA
b2Vec2 | m_localAnchorB
b2Vec2 | m_localXAxisA
b2Vec2 | m_localYAxisA
float32 | m_impulse
float32 | m_motorImpulse
float32 | m_springImpulse
float32 | m_maxMotorTorque
float32 | m_motorSpeed
bool | m_enableMotor
int32 | m_indexA
int32 | m_indexB
b2Vec2 | m_localCenterA
b2Vec2 | m_localCenterB
float32 | m_invMassA
float32 | m_invMassB
float32 | m_invIA
float32 | m_invIB
b2Vec2 | m_ax
b2Vec2 | m_ay
float32 | m_sAx
float32 | m_sBx
float32 | m_sAy
float32 | m_sBy
float32 | m_mass
float32 | m_motorMass
float32 | m_springMass
float32 | m_bias
float32 | m_gamma
Protected Attributes inherited from b2Joint
b2JointType | m_type
b2Joint * | m_prev
b2Joint * | m_next
b2JointEdge | m_edgeA
b2JointEdge | m_edgeB
b2Body * | m_bodyA
b2Body * | m_bodyB
int32 | m_index
bool | m_islandFlag
bool | m_collideConnected
void * | m_userData

## Friends
class | b2Joint

## Additional Inherited Members
Static Protected Member Functions inherited from b2Joint
static b2Joint * | Create (const b2JointDef *def, b2BlockAllocator *allocator)
static void | Destroy (b2Joint *joint, b2BlockAllocator *allocator)

## Detailed Description

A wheel joint. This joint provides two degrees of freedom: translation along an axis fixed in bodyA and rotation in the plane. You can use a joint limit to restrict the range of motion and a joint motor to drive the rotation or to model rotational friction. This joint is designed for vehicle suspensions.

## Constructor & Destructor Documentation

b2WheelJoint | ( | const b2WheelJointDef * | def | ) |
| protected

## Member Function Documentation

void Dump | ( |  | ) |
| virtual

Dump to b2Log.

Reimplemented from b2Joint.

void EnableMotor | ( | bool | flag | ) |

Enable/disable the joint motor.

b2Vec2 GetAnchorA | ( |  | ) | const
| virtual

Get the anchor point on bodyA in world coordinates.

Implements b2Joint.

b2Vec2 GetAnchorB | ( |  | ) | const
| virtual

Get the anchor point on bodyB in world coordinates.

Implements b2Joint.

void GetDefinition | ( | b2WheelJointDef * | def | ) | const

float32 GetJointSpeed | ( |  | ) | const

Get the current joint translation speed, usually in meters per second.

float32 GetJointTranslation | ( |  | ) | const

Get the current joint translation, usually in meters.

const b2Vec2& GetLocalAnchorA | ( |  | ) | const
| inline

The local anchor point relative to bodyA's origin.

const b2Vec2& GetLocalAnchorB | ( |  | ) | const
| inline

The local anchor point relative to bodyB's origin.

const b2Vec2& GetLocalAxisA | ( |  | ) | const
| inline

The local joint axis relative to bodyA.

float32 GetMaxMotorTorque | ( |  | ) | const
| inline

float32 GetMotorSpeed | ( |  | ) | const
| inline

Get the motor speed, usually in radians per second.

float32 GetMotorTorque | ( | float32 | inv_dt | ) | const

Get the current motor torque given the inverse time step, usually in N-m.

b2Vec2 GetReactionForce | ( | float32 | inv_dt | ) | const
| virtual

Get the reaction force on bodyB at the joint anchor in Newtons.

Implements b2Joint.

float32 GetReactionTorque | ( | float32 | inv_dt | ) | const
| virtual

Get the reaction torque on bodyB in N*m.

Implements b2Joint.

float32 GetSpringDampingRatio | ( |  | ) | const
| inline

float32 GetSpringFrequencyHz | ( |  | ) | const
| inline

void InitVelocityConstraints | ( | const b2SolverData & | data | ) |
| protected virtual

Implements b2Joint.

bool IsMotorEnabled | ( |  | ) | const

Is the joint motor enabled?

void SetMaxMotorTorque | ( | float32 | torque | ) |

Set/Get the maximum motor force, usually in N-m.

void SetMotorSpeed | ( | float32 | speed | ) |

Set the motor speed, usually in radians per second.

void SetSpringDampingRatio | ( | float32 | ratio | ) |
| inline

Set/Get the spring damping ratio.

void SetSpringFrequencyHz | ( | float32 | hz | ) |
| inline

Set/Get the spring frequency in hertz. Setting the frequency to zero disables the spring.

bool SolvePositionConstraints | ( | const b2SolverData & | data | ) |
| protected virtual

Implements b2Joint.

void SolveVelocityConstraints | ( | const b2SolverData & | data | ) |
| protected virtual

Implements b2Joint.

## Friends And Related Function Documentation

friend class b2Joint
| friend

## Member Data Documentation

b2Vec2 m_ax
| protected

b2Vec2 m_ay
| protected

float32 m_bias
| protected

float32 m_dampingRatio
| protected

bool m_enableMotor
| protected

float32 m_frequencyHz
| protected

float32 m_gamma
| protected

float32 m_impulse
| protected

int32 m_indexA
| protected

int32 m_indexB
| protected

float32 m_invIA
| protected

float32 m_invIB
| protected

float32 m_invMassA
| protected

float32 m_invMassB
| protected

b2Vec2 m_localAnchorA
| protected

b2Vec2 m_localAnchorB
| protected

b2Vec2 m_localCenterA
| protected

b2Vec2 m_localCenterB
| protected

b2Vec2 m_localXAxisA
| protected

b2Vec2 m_localYAxisA
| protected

float32 m_mass
| protected

float32 m_maxMotorTorque
| protected

float32 m_motorImpulse
| protected

float32 m_motorMass
| protected

float32 m_motorSpeed
| protected

float32 m_sAx
| protected

float32 m_sAy
| protected

float32 m_sBx
| protected

float32 m_sBy
| protected

float32 m_springImpulse
| protected

float32 m_springMass
| protected

The documentation for this class was generated from the following files:

- Box2D/Dynamics/Joints/b2WheelJoint.h
- Box2D/Dynamics/Joints/b2WheelJoint.cpp